package tank

import (
	"fmt"
	"wartank/pkg/types"
	"wartank/server/serv_bots/warbot/tank/tankstat"
)

/*
	Исходник предоставляет тип со свойствами танка.
	Глобальный объект.
*/

// Танк -- описатель танка
type Танк struct {
	параметры types.ИТанкСтат // Глобальная статистика танка и сервера
}

// NewTank -- возвращает новый *Tank
func NewTank() (*Танк, error) {
	стата, ош := tankstat.NewTankStat()
	if ош != nil {
		return nil, fmt.Errorf("NewTank(): при создании статы, ош=\n\t%w", ош)
	}
	sf := &Танк{
		параметры: стата,
	}
	return sf, nil
}

// ТанкСтат -- возвращает объект статистики танка
func (sf *Танк) ТанкСтат() types.ИТанкСтат {
	return sf.параметры
}
